package FreqPolygonS;

import java.io.*;
import javafx.application.Application;
import javafx.scene.*;
import javafx.scene.chart.*;
import javafx.scene.layout.*;
import javafx.stage.*;

public class FreqPolygonS extends Application {

	@Override
	public void start(Stage stage){
			String VarLabel = "_";	//		ϐ
			double data[] = {			//		f[^i[pz
								66, 59, 62, 64, 63, 
								68, 65, 59, 68, 64,
								65, 51, 67, 64, 83,
								59, 61, 62, 57, 72,
								65, 64, 54, 60, 53,
								65, 67, 60, 53, 79,
								74, 53, 61, 68, 75,
								50, 57, 55, 66, 56,
								55, 61, 70, 71, 49,
								69, 70, 80, 73, 72	
							};
			int n = data.length;

			int n_intvl = 0;
			double x_value[] = {};
			int IntvlFreq[] = {};			
			try{
				//
				//				L[{[h͂obt@[tŐݒ
				//
				BufferedReader cin = new BufferedReader( new InputStreamReader(System.in) );

				double minX = data[0], maxX = data[0];
				for (int i = 0; i < n; i++){
					//
					//		f[^̊mFpo
					//
					System.out.println("data[" + (i + 1) + "] = " + data[i]);
					//
					//		ŏlAől߂
					//
					if (minX > data[i]) minX = data[i];
					if (maxX < data[i]) maxX = data[i];
				}
				System.out.println("\nmin = " + minX + "    max = " + maxX);
				double LB;		//		xz̍[̒l
				double UB;		//		xz̉E[̒l
				while(true){
					System.out.print("Lower Boundary Value = ");
					LB = Double.parseDouble(cin.readLine());
					System.out.print("Upper Boundary Value = ");
					UB = Double.parseDouble(cin.readLine());
					if ((LB < minX) &&  (UB > maxX)) break;
					System.out.println("LB or UB  is not valid.");
				}
				System.out.print("Number of intervals = ");
				n_intvl = Integer.parseInt(cin.readLine());		//		xz̊K
				double w_intvl = (UB - LB) / n_intvl;			//		K̋Ԃ̕
				n_intvl += 2;									//		[ɓxŐԂǉ
				x_value = new double[n_intvl];
				for (int i = 0; i < n_intvl; i++){
					x_value[i] = LB - (0.5 * w_intvl) + i * w_intvl;			//		K̋Ԃ̒l
					System.out.println("x_value[" + i + "] = " + x_value[i]);
				} 
				double cx_value[] = new double[n_intvl - 1];
				for (int i = 0; i < n_intvl - 1; i++){
					cx_value[i] = x_value[i] + 0.5 * w_intvl;				//		K̋El
					System.out.println("cx_value[" + i + "] = " + cx_value[i]);
				}
				//
				//			K̓x𐔂
				//
				IntvlFreq = new int[n_intvl];
				for (int i = 0; i < n_intvl; i++)
					IntvlFreq[i] = 0;
				for (int i = 0; i < n; i++){
					int id = 0;
					while((data[i] > cx_value[id]) && (id < (n_intvl - 1))) id++;
					if (data[i] > cx_value[id]) id++;
					IntvlFreq[id]++;					//		f[^̏K̓xP₷
				}
				System.out.println();
				int sum = 0;
				for (int i = 0; i < n_intvl; i++){
					System.out.println("IntvlFreq[" + i + "] = " + IntvlFreq[i]);
					sum += IntvlFreq[i];
				}
				System.out.println("sum = " + sum);
			}
			catch(Exception e){
				System.out.println("Exception..." + e);
				System.exit(1);
			}

		/*---------------------------------------------------

						xp`̕`

		-----------------------------------------------------*/

		stage.setTitle("xp`");

		NumberAxis x_axis = new NumberAxis();
		x_axis.setLabel("K̒l");
		NumberAxis y_axis = new NumberAxis();
		y_axis.setLabel("x@");

		XYChart.Series<Number, Number> xy_series = new XYChart.Series<>();
		xy_series.setName("K̓x");
		for (int i = 0; i < n_intvl; i++)
			xy_series.getData().add(new XYChart.Data<>(x_value[i], IntvlFreq[i]));
			
		LineChart<Number, Number> freqPoly = new LineChart<>(x_axis, y_axis);
		freqPoly.setTitle(VarLabel + "̓xp`");
		freqPoly.getData().add(xy_series);

		HBox root = new HBox();
		root.getChildren().add(freqPoly);
		stage.setScene( new Scene(root, 800, 600) );
		stage.show();
	}

}